//
// Written by Igor Tolmachev, IT Samples
//        mailto:support@itsamples.com
//
// Copyright (c) 2009.
//
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name and all copyright 
// notices remains intact. If the source code in this file is used in 
// any  commercial application then a statement along the lines of 
// "Portions copyright (c) Igor Tolmachev, 2009" must be included in 
// the startup banner, "About" box or printed documentation. An email 
// letting me know that you are using it would be nice as well. That's 
// not much to ask considering the amount of work that went into this.
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability for any damage/loss of business that
// this product may cause.
//
// Expect bugs!
// 
// Please use and enjoy, and let me know of any bugs/mods/improvements 
// that you have found/implemented and I will fix/incorporate them into 
// this file. 

// *******************************************************************
// File    : MainFrm.h 

#if !defined(AFX_MAINFRM_H__F0EC7B57_8811_46EB_AD7B_438761B8C5E1__INCLUDED_)
#define AFX_MAINFRM_H__F0EC7B57_8811_46EB_AD7B_438761B8C5E1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define KEYBOARD_CAPS_LOCK     4
#define KEYBOARD_NUM_LOCK      2
#define KEYBOARD_SCROLL_LOCK   1

#define WM_ICONTRAY            WM_USER+777

#define IOCTL_KEYBOARD_SET_INDICATORS        CTL_CODE(FILE_DEVICE_KEYBOARD, 0x0002, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_KEYBOARD_QUERY_INDICATORS      CTL_CODE(FILE_DEVICE_KEYBOARD, 0x0010, METHOD_BUFFERED, FILE_ANY_ACCESS)

struct SKeyInfo
{
    USHORT nUnitId;		// Unit identifier.
    USHORT nLedFlags;	// LED indicator state.
};

class CMainFrame : public CNewFrameWnd
{
	
public:
	CMainFrame();

protected: 
	DECLARE_DYNAMIC(CMainFrame)
	HANDLE OpenKeyboardDevice();
	void FlashNumLock();
	void FlashScrollLock();
	void ResetIndicators();
	void GetSettings();
	BOOL TrayMessage (HWND hDlg, DWORD dwMessage, UINT uID, HICON hIcon, PSTR pszTip);

// Attributes
public:
	HANDLE           m_hDev;
	UINT             m_nDuration;
	BOOL             m_bIsWinNT;
	BOOL             m_bIsForced;
	CWinThread*      m_pTxThread;
	CWinThread*      m_pRxThread;
	BOOL             m_bRxContinue;
	BOOL             m_bTxContinue;

// Operations
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg LRESULT OnIconTray(WPARAM wParam, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnAbout();
	afx_msg void OnSettings();
	afx_msg void OnStatistics();
	afx_msg void OnExit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__F0EC7B57_8811_46EB_AD7B_438761B8C5E1__INCLUDED_)
